#line 1 "C:/Users/Temelko/Desktop/ATtiny2313_AD7328_USI/source/ATtiny2313_AD7328_USI.c"
#line 1 "c:/users/temelko/desktop/attiny2313_ad7328_usi/source/defs.h"
#line 3 "C:/Users/Temelko/Desktop/ATtiny2313_AD7328_USI/source/ATtiny2313_AD7328_USI.c"
void spiInit() {


 DDRB &= ~(1<< PORTB5 );


 DDRB |= ((1<< PORTB6 ) | (1<< PORTB7 ) | (1<< PORTB4 ));


 USICR &= ~(1<<USIWM1);
 USICR |= (1<<USIWM0);


 PORTB |= ~(0<< PORTB4 );

 return;
}

unsigned int shft16bit(unsigned int val) {
unsigned char higherByte, lowerByte;
unsigned int res;
const unsigned char CR = (1<<USIWM0) | (1<<USICS1) | (1<<USICLK) | (1<<USITC);

 higherByte = (unsigned char)((val & 0xFF00) >> 8);
 lowerByte = (unsigned char)(val & 0x00FF);

 PORTB &= (0<< PORTB4 );

 USIDR = higherByte;
 USISR |= (1<<USIOIF);

 do {
 USICR = CR;
 } while ((USISR & (1<<USIOIF)) == 0);

 res = USIDR << 8;



 USIDR = lowerByte;
 USISR |= (1<<USIOIF);

 do {
 USICR = CR;
 } while ((USISR & (1<<USIOIF)) == 0);

 res |= USIDR;

 PORTB |= ~(0<< PORTB4 );

 return res;
}


void setRangeRegister(unsigned char ch, unsigned char range) {
unsigned int range_ = 0xA000;

 if ((ch < 0) || (ch > 7)) return;

 switch (ch) {
 case 0:
 range_ &=  0xE7FF ;
 range_ |= range << 11;
 break;
 case 1:
 range_ &=  0xF9FF ;
 range_ |= range << 9;
 break;
 case 2:
 range_ &=  0xFE7F ;
 range_ |= range << 7;
 break;
 case 3:
 range_ &=  0xFF9F ;
 range_ |= range << 5;
 break;
 case 4:
 range_ = range &  0xE7FF ;
 range_ |= range << 11;
 break;
 case 5:
 range_ = range &  0xF9FF ;
 range_ |= range << 9;
 break;
 case 6:
 range_ = range &  0xFE7F ;
 range_ |= range << 7;
 break;
 case 7:
 range_ = range &  0xFF9F ;
 range_ |= range << 5;
 break;
 default: break;
 }

 shft16bit(range_);

 return;
}

void setControlRegister(unsigned char ch, unsigned int setup) {

 if ((ch < 0) || (ch > 7)) return;

 setup |= ((ch & 0x07) << 10);

 shft16bit(setup);

 return;
}

void ADC7328init(void) {
unsigned char i = 0;

 for (i = 0; i < 7; i++) setRangeRegister(i,  0x00 );
 setControlRegister(0,  0x8030 );
 shft16bit(0xFE00);

 return;
}

void main() {
unsigned int result = 0;
char buffer[8];

 spiInit();
 ADC7328init();

 CLKPR = 0x80;
 CLKPR = 0x00;
 UART1_Init_Advanced(9600, _UART_NOPARITY, _UART_ONE_STOPBIT);
 Delay_ms(100);

 while (1) {
 result = shft16bit(0x0000) & 0x1FFF;
 if ((result & 0x1000) >> 12)
 IntToStr(result & 0x0FFF, buffer);
 else
 IntToStr((~result) & 0x0FFF, buffer);
 UART1_Write_Text(buffer);
  UART1_Write(13); UART1_Write(10) ;
 Delay_ms(250);
 }

 return;
}
