// https://github.com/janelia-arduino/AD7328/blob/master/src/AD7328.h
#ifndef defs_h
#define defs_h

#define nl() UART1_Write(13); UART1_Write(10)

// range constants
#define BIP10  0x00 // +/-10V
#define BIP5   0x01 // +/-5V
#define BIP2V5 0x02 // +/-2.5
#define UNI10  0x03 // +10V

#define CH0_MASK 0xE7FF // 0b1110011111111111
#define CH1_MASK 0xF9FF // 0b1111100111111111
#define CH2_MASK 0xFE7F // 0b1111111001111111
#define CH3_MASK 0xFF9F // 0b1111111110011111
#define CH4_MASK 0xE7FF // 0b1110011111111111
#define CH5_MASK 0xF9FF // 0b1111100111111111
#define CH6_MASK 0xFE7F // 0b1111111001111111
#define CH7_MASK 0xFF9F // 0b1111111110011111

#define USI_SCK PORTB7
#define USI_DO  PORTB6
#define USI_DI  PORTB5
#define USI_CS  PORTB4

// sequence is not used, straight binary output coding, normal power mode, single ended channel
#define SETUP_1 0x8030//0b1000000000110000;
// sequence is used, straight binary output coding, normal power mode, single ended channel
#define SETUP_2 0x8034//0b1000000000110100

#endif